

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 25.11.2006
*/

// Klasse, die einen Knoten im Baum reprsentiert
// Die wichtigen Daten, Pfad, etc, werden als
// Userobject angehngt, siehe cTreeNode

// Weiter speichert man die Anzahl der vorhanden SubDirs
// Dies ist wichtig, wenn man dem Baum aufklappen will
// siehe Abfrage  AnzSubDir(java)==0   &&  AnzRealSubDir>0

import javax.swing.tree.DefaultMutableTreeNode;

public class CDefaultMutableTreeNode  extends DefaultMutableTreeNode {
    
    private int _AnzSubDir=0;  // wichtig frs Aufklappen
    
    /** Creates a new instance of MyDefaultMutableTreeNode */
    public CDefaultMutableTreeNode() {
        this(0);
    }
    

    public CDefaultMutableTreeNode(Object userObject) {
        this(userObject, true, 0);
    }

    public CDefaultMutableTreeNode(Object userObject, boolean allowsChildren, int AnzSubDir) {
        super( userObject, allowsChildren);
        _AnzSubDir = AnzSubDir;
    }
    
    public void setAnzSubdir(int AnzSubDir) {
        _AnzSubDir = AnzSubDir;
    }
    
    
   public int getAnzSubDir() {
       return _AnzSubDir;
   }
    
}
