

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 25.11.2006
*/

// Kapselt die Komponenten eines Toolbar im Hauptfenster
// Sourcecode ist aufgerumter

// ActionPerformed mittels  Interface
// ruft also das Hautfenster auf
// hat ja keinen Zugriff wie im blichen Sinne
// ist aber modularer und aufgerumter

// die zusatzverzeichnisse mssen aber noch in einem 
// Einstellungsfenster angezeigt werden

// Klassen importieren
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;



// implements ActionListener  sorgt dafr
//   dass man keine Actionperformed definieren muss
public class CJToolBar extends JToolBar implements ActionListener {
	// Referenz auf das Explorer-Fenster
  	IExplorer iex;	
        
  	// Deklaration der Buttonleiste                 
  	ButtonGroup bg;                  
								  	
	// Konstruktor							
  	public CJToolBar(IExplorer iex) {
            super();					 
            this.iex=iex;
            makeRootButtons();
            makeSecondsButtons();
  	}//ToolLeiste

	// Button mit den Laufwerken erstellen
  void makeRootButtons() {
      // Liste der Laufwerke
    File[] driveList = File.listRoots();
    	// neue Buttonleiste erstellen
    	bg=new ButtonGroup();
    	// Feld durchlaufen
    	for(int i=0;i<driveList.length;i++) {
    		// Button erstellen mit den Laufwerken (Buchstaben)
      		JToggleButton bn=new JToggleButton(driveList[i].getPath());
                bn.setFont( new Font("Arial", Font.BOLD,18)  );

                add( bn );
                addSeparator( new Dimension(20,5) );

      		// Tip Anzeigen bei Mauskontakt
      		bn.setToolTipText("Wechseln zu Laufwerk "+driveList[i].getPath());
      		// gibt auf Tastendruck den Pfad des Laufwerkes
      		bn.setActionCommand("Root"+driveList[i].getPath());
      		// Abstaende einstellen
      		bn.setMargin(new Insets(2,2,2,2));
      		// hinzufuegen des ActionListeners
      		bn.addActionListener(this);
          // suche das aktuelle Verzeichnis, ist es identisch mit Laufwerk
      		//bn.setSelected(bn.getText().equals(System.getProperty("user.dir").substring(0,3)));
                bn.setSelected( i==0 );
                
      		// Button der Buttongroup hinzufuegen
      		bg.add(bn);
    	}//for
  }//makeRootButtons
  
  

	// Button mit den Links zu Verzeichnissen erstellen
  void makeSecondsButtons() {
    String sVerz [] = new String [] {"D:\\hs-harz\\vorlesungen", "D:\\visual_studio\\"} ;
    for (int i=0; i<sVerz.length; i++) {
        JToggleButton bn=new JToggleButton("V"+Integer.toString(i+1) );
        bn.setFont( new Font("Arial", Font.BOLD,18)  );
        add( bn );
        addSeparator( new Dimension(20,5) );

        // Tip Anzeigen bei Mauskontakt
        bn.setToolTipText(sVerz[i]);
        // gibt auf Tastendruck den Pfad des Laufwerkes
        bn.setActionCommand( sVerz[i] );
        // Abstaende einstellen
        bn.setMargin(new Insets(2,2,2,2));
        // hinzufuegen des ActionListeners
        bn.addActionListener(this);
        // Button der Buttongroup hinzufuegen
        bg.add(bn);
    }
  }//makeSecondsButton


  
  public void actionPerformed(ActionEvent e) {
  		// herausloesen des Root, Kontrolle des Aufrufes
    	if(e.getActionCommand().substring(0,4).equals("Root")) {  
    		// Loeschen von Root => Laufwerk C:\ hat RootC:\
      		String sStr=e.getActionCommand().substring(4);            
      	   	System.out.println("ToolLeiste actionPerformed "+sStr); 
      	   	// Aufruf von setRoot im Explorer mit Uebergabe des Laufwerks
      		iex.setRoot(sStr);                                         
      	}
        else  {
            // Hier werden feste Verzeichnisse "verdrahtet"
            // zum Beispiel  C:\\daten\gui\labor1
            String sStr=e.getActionCommand();
            System.out.println("ToolLeiste actionPerformed "+sStr); 
            // Aufruf von setRoot im Explorer mit Uebergabe des Laufwerks
            iex.setRoot(sStr);                                         
        }
  }//actionPerformed
  	
}//ToolLeiste