

/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   EMail:           mwilhelm@hs-harz.de
   Projekt:         JExplorer
   Version:         0.8
   Ersterstellung:  10.10.2006
   Letzte nderung: 25.11.2006
*/

// Freies Fenster, dass die Zeilen aller bergebenen Dateien zhlt
// Natrlich mit einem Thread
// UND es regelt die Single-Thread-Rule, AWT-Problem

import java.awt.*;
import java.io.File;
import javax.swing.*;
import javax.swing.event.*;

import java.awt.event.*;


// frs lesen aus Datei
import java.io.*;

import java.util.Vector;

public class JFRowCount extends  JFrame {
      JLabel label1;
      JLabel label2;

      JLabel label3;
      JLabel label4;

      JLabel label5;
      JLabel label6;
    
      JProgressBar _progress;
        
    /** Creates a new instance of JFRowCount */
    public JFRowCount() {
        setSize(450,280);
        setGUI();
        CBasis.centerScreen(this,null);
    }
    
    
    private void setGUI() {
      this.getContentPane().setLayout( new GridBagLayout() );

      label1 = new JLabel("Anzahl der Dateien");
      label2 = new JLabel("0");

      label3 = new JLabel("Anzahl Zeilen ohne Leerzeichen");
      label4 = new JLabel("0");

      label5 = new JLabel("Anzahl Zeilen mit Leerzeichen");
      label6 = new JLabel("0");

      label1.setFont( new Font("Arial", Font.BOLD,18)  );        
      label2.setFont( new Font("Arial", Font.BOLD,18)  );        
      label3.setFont( new Font("Arial", Font.BOLD,18)  );        
      label4.setFont( new Font("Arial", Font.BOLD,18)  );        
      label5.setFont( new Font("Arial", Font.BOLD,18)  );        
      label6.setFont( new Font("Arial", Font.BOLD,18)  );        
      
      this.getContentPane().add(label1, 
              new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
              new Insets(10,20,0,0), 0, 0));

      this.getContentPane().add(label2,   
              new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
              new Insets(10,20,0,20), 0, 0));

      
      this.getContentPane().add(label3, 
              new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
              new Insets(20,20,0,0), 0, 0));

      this.getContentPane().add(label4,   
              new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
              new Insets(20,20,0,20), 0, 0));


      this.getContentPane().add(label5, 
              new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.NONE, 
              new Insets(20,20,0,0), 0, 0));

      this.getContentPane().add(label6,   
              new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
              new Insets(20,20,0,20), 0, 0));

      
      
      _progress = new JProgressBar();
      this.getContentPane().add(_progress,   
              new GridBagConstraints(0, 3, 2, 1, 1.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
              new Insets(20,20,0,20), 0, 15));  // 15=feste Hhe !!!

      JButton BnOk = new JButton("Ok");
      BnOk.setFont( new Font("Arial", Font.BOLD,18)  );        

      JPanel pnBn = new JPanel();
      pnBn.add(BnOk);

      this.getContentPane().add(pnBn,   
              new GridBagConstraints(0, 4, 2, 1, 1.0, 0.0
                ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, 
              new Insets(20,20,0,20), 0, 0));
      
      BnOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
              BnOk_Click();
            }
          });
      
    }  // setGUI
    
    // Fenster kann immer abgebrochen werden
    private void BnOk_Click() {
        dispose();
    }
    public void calcRowsCount(Vector liste) {
        label2.setText( Long.toString(liste.size() )   );
        RowCountThread thread = new RowCountThread(liste, _progress, label4, label6);
        thread.start();
    }

    // fhrt zu einem Absturz, verletzt die Single Thread Rule
    public void calcRowsCount2(Vector liste) {
        label2.setText( Long.toString(liste.size() )   );
        RowCountThread2 thread = new RowCountThread2(liste, _progress, label4, label6);
        thread.start();
    }
    
    
    class RowCountThread  extends Thread {
        Vector _liste;
        long _summe1=0;  // ohne leerzeichen
        long _summe2=0;  // mit Leerzeichen
        JLabel _label1, _label2;
        JProgressBar _progress;
        
        public RowCountThread(Vector liste, JProgressBar progress, JLabel label1, JLabel label2) {
            _liste = liste;
            _label1 = label1;
            _label2 = label2;
            _progress = progress;
        }

        public void run() {
            _summe1=0;
            _summe2=0;
            _progress.setMinimum(0);
            _progress.setMaximum(_liste.size());
            _progress.setValue(0);        
            for (int i=0; i<_liste.size(); i++) {
                getRowCount( (CFile) _liste.elementAt(i) );
                  final int Runnable_i=i;
                  SwingUtilities.invokeLater(
                    new Runnable(){
                        public void run() {
                            _progress.setValue(Runnable_i);
                            _progress.updateUI();
                        }
                    }
                 );  // invokeLater
                 try {
                    Thread.sleep(50);
                  }
                  catch (InterruptedException e) {
                  }                
            }
            _label1.setText( Long.toString(_summe1)  );
            _label2.setText( Long.toString(_summe2)  );
        } // run
            
        private void getRowCount(CFile cfile) {
            FileInputStream fin;
            InputStreamReader iin;
            LineNumberReader din;
                // aktuelle Version zum Einlesen einer ASCII-Datei
            String sLine;
            try {
              fin = new FileInputStream(  cfile.fullPath  );
              iin = new InputStreamReader(fin);
              din = new LineNumberReader(iin);
              while  ( din.ready()  ) {
                sLine = din.readLine().trim();
                if (sLine.length()>0)
                    _summe1++;
                _summe2++;
                //System.out.println(sLine);
              }
            }
            catch (IOException e) {
                   System.err.println("IOException: " + e);
            }

        }
            
    }

}


// berflssig, dient aber zur Demonstration der Verletzung
// der Single-Thread-Rule
class RowCountThread2 extends Thread {
    
    Vector _liste;
    long _summe1=0;  // Summe ohne leerzeichen
    long _summe2=0;  // Summe mit Leerzeichen
    // Referenzen auf die parent-GUI's
    JLabel _label1, _label2;
    JProgressBar _progress;
    
    public RowCountThread2(Vector liste, JProgressBar progress, JLabel label1, JLabel label2) {
        _liste = liste;
        _label1 = label1;
        _label2 = label2;
        _progress = progress;
    }
    
    // Thread Methode
    public void run() {
        _summe1=0;
        _summe2=0;
        _progress.setMinimum(0);
        _progress.setMaximum(_liste.size());
        _progress.setValue(0);        
        for (int i=0; i<_liste.size(); i++) {
            getRowCount( (CFile) _liste.elementAt(i) );
            _progress.setValue(i+1);
            _progress.updateUI();
             try {
                Thread.sleep(50);
              }
              catch (InterruptedException e) {
              }                
        }
        _label1.setText( Long.toString(_summe1)  );
        _label2.setText( Long.toString(_summe2)  );
    }

    // bestimmt die Zeilenlnge der Datei
    // Verwendet die gloablen Variablen _summe1, _summe2
    private void getRowCount(CFile cfile) {
        FileInputStream fin;
        InputStreamReader iin;
        LineNumberReader din;
            // aktuelle Version zum Einlesen einer ASCII-Datei
        String sLine;
        try {
          fin = new FileInputStream(  cfile.fullPath  );
          iin = new InputStreamReader(fin);
          din = new LineNumberReader(iin);
          while  ( din.ready()  ) {
            sLine = din.readLine().trim();
            if (sLine.length()>0)
                _summe1++;
            _summe2++;
            //System.out.println(sLine);
          }
        }
        catch (IOException e) {
               System.err.println("IOException: " + e);
        }
        
    }
    
}
